﻿// <auto-generated />
using System;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Metadata;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using Noroff.Samples.EFCore.DDDActivity.DataAccess;

#nullable disable

namespace Noroff.Samples.EFCore.DDDActivity.Migrations
{
    [DbContext(typeof(UniversityContext))]
    [Migration("20231115083719_initialDb")]
    partial class initialDb
    {
        /// <inheritdoc />
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "7.0.13")
                .HasAnnotation("Relational:MaxIdentifierLength", 128);

            SqlServerModelBuilderExtensions.UseIdentityColumns(modelBuilder);

            modelBuilder.Entity("Noroff.Samples.EFCore.DDDActivity.Domain.StudentAggregate.Enrollment", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int");

                    SqlServerPropertyBuilderExtensions.UseIdentityColumn(b.Property<int>("Id"));

                    b.Property<int>("CourseId")
                        .HasColumnType("int");

                    b.Property<int>("StudentId")
                        .HasColumnType("int");

                    b.HasKey("Id");

                    b.HasIndex("StudentId");

                    b.ToTable("Enrollments");
                });

            modelBuilder.Entity("Noroff.Samples.EFCore.DDDActivity.Domain.StudentAggregate.Student", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int");

                    SqlServerPropertyBuilderExtensions.UseIdentityColumn(b.Property<int>("Id"));

                    b.Property<string>("Address")
                        .IsRequired()
                        .HasColumnType("nvarchar(max)");

                    b.Property<DateTime>("DateOfBirth")
                        .HasColumnType("datetime2");

                    b.Property<string>("Email")
                        .IsRequired()
                        .HasColumnType("nvarchar(max)");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("nvarchar(max)");

                    b.Property<byte[]>("RowVersion")
                        .IsConcurrencyToken()
                        .IsRequired()
                        .ValueGeneratedOnAddOrUpdate()
                        .HasColumnType("rowversion");

                    b.HasKey("Id");

                    b.ToTable("Students");
                });

            modelBuilder.Entity("Noroff.Samples.EFCore.DDDActivity.Domain.StudentAggregate.Enrollment", b =>
                {
                    b.HasOne("Noroff.Samples.EFCore.DDDActivity.Domain.StudentAggregate.Student", null)
                        .WithMany("Enrollments")
                        .HasForeignKey("StudentId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.OwnsOne("Noroff.Samples.EFCore.DDDActivity.Domain.StudentAggregate.Grade", "Grade", b1 =>
                        {
                            b1.Property<int>("EnrollmentId")
                                .HasColumnType("int");

                            b1.Property<string>("Letter")
                                .IsRequired()
                                .HasColumnType("nvarchar(max)")
                                .HasColumnName("GradeLetter");

                            b1.Property<decimal>("NumericValue")
                                .HasColumnType("decimal(18,2)")
                                .HasColumnName("GradeNumericValue");

                            b1.HasKey("EnrollmentId");

                            b1.ToTable("Enrollments");

                            b1.WithOwner()
                                .HasForeignKey("EnrollmentId");
                        });

                    b.Navigation("Grade");
                });

            modelBuilder.Entity("Noroff.Samples.EFCore.DDDActivity.Domain.StudentAggregate.Student", b =>
                {
                    b.Navigation("Enrollments");
                });
#pragma warning restore 612, 618
        }
    }
}
